/** @module deliteful/list/List */
define([ "dcl/dcl", "delite/register", "delite/Widget", "delite/Store" ],
	function (dcl, register, Widget, Store) {

		console.log("deliteful/List, dcl is", dcl, "equal?", window.x === dcl);

		var ListBase = dcl([HTMLElement, Widget, Store ], {

			////////////delite/Store implementation ///////////////////////////////////////
			queryStoreAndInitItems: function () {
				this.shouldInitializeRendering();
				this.initItems([1,2,3,4,5]);
			},

			shouldInitializeRendering: dcl.superCall(function (sup) {
				return function () {
					console.log("subclass shouldInitializeRendering");
					return sup.call(this);
				};
			}),

			/**
			 * Populate the list using the items retrieved from the store.
			 * @param {Object[]} items items retrieved from the store.
			 * @protected
			 * @fires module:delite/Store#query-success
			 */
			initItems: dcl.superCall(function (sup) {
				console.log("initItems super is", sup);
				return function (items) {
					console.log("initItems in subclass");
					return sup.call(this, items);
				};
			})
		});

		try {
			var lb = new ListBase();
			lb.initItems([1,2,3,4,5]);
		} catch (e) {}

		var List = register("d-list", [ HTMLElement, ListBase ], {});
		var l = new List();
		l.initItems([1,2,3,5]);
		return List;
	});


